package xyz.danielcortes.controllers.editorial;

import javax.swing.JOptionPane;
import xyz.danielcortes.models.Editorial;
import xyz.danielcortes.repository.EditorialRepository;
import xyz.danielcortes.views.editorial.EditorialCreatePanel;

public class EditorialCreateController {

  private EditorialRepository editorialRepository;
  private EditorialCreatePanel view;

  public EditorialCreateController(EditorialCreatePanel view) {
    this.view = view;
    this.editorialRepository = new EditorialRepository();

    this.setupListeners();
  }

  private void setupListeners() {
    this.view.getGuardarButton().addActionListener(e -> save());
    this.view.getNombreField().addActionListener(e -> save());
  }

  private void save() {
    String nombre = this.view.getNombreField().getText();
    if(!validateNombre(nombre)) return;

    Editorial editorial = new Editorial();
    editorial.setNombre(nombre);

    editorialRepository.save(editorial);

    this.view.getNombreField().setText("");
    this.view.getNombreField().requestFocus();
  }

  private boolean validateNombre(String nombre) {
    if (nombre == null) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre es nulo",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    } else if (nombre.isEmpty()) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre esta vacío",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  public EditorialCreatePanel getView() {
    return view;
  }
}
